<template>
  <div class="container-xxl">
    <div class="row mt-5">
      <div class="col-12 col-md-4 col-lg-5 col-xl-4 mt-2">
        <div
          id="transporte_buscar_formulario"
          class="card card-flush shadow-sm"
        >
          <div class="card-body">
            <div class="d-flex flex-column justify-content-start">
              <div class="d-flex flex-column mt-2">
                <input
                  v-model="mFormulario.toneladaMin"
                  type="number"
                  step="1"
                  class="form-control"
                  placeholder="Tonelada mínima"
                >
              </div>

              <div class="d-flex flex-column mt-2">
                <input
                  v-model="mFormulario.toneladaMax"
                  type="number"
                  step="1"
                  class="form-control"
                  placeholder="Tonelada máxima"
                >
              </div>

              <div class="d-flex flex-column mt-2">
                <button
                  id="transporte_buscar_btn_buscar"
                  class="btn btn-primary"
                  @click="onTransporteBuscar()"
                >
                  <i class="bi bi-search fs-4 me-2" />Buscar
                </button>
              </div>

              <div class="d-flex flex-column mt-2">
                <a
                  class="btn btn-link"
                  data-bs-toggle="collapse"
                  aria-expanded="true"
                  href="#transporte_buscar_opcion_avanzada"
                >Opciones avanzadas</a>
              </div>
            </div>

            <div
              id="transporte_buscar_opcion_avanzada"
              class="collapse show"
            >
              <div class="separator separator-dashed mt-9 mb-6" />

              <div class="row g-8">
                <div class="col-12 col-xxl-6">
                  <label class="fs-6 form-label fw-bolder text-dark">Metros de largo Min.</label>
                  <InputMarcador
                    ref="transporteBuscarInputLargoMin"
                    identificador="transporte_buscar_input_largo_min"
                    :valor-min="0"
                    :valor-max="50"
                    :valor-escala="1"
                    :valor-inicial="0"
                    titulo="Metros de largo mínimo"
                  />
                </div>

                <div class="col-12 col-xxl-6">
                  <label class="fs-6 form-label fw-bolder text-dark">Metro de largo Max.</label>
                  <InputMarcador
                    ref="transporteBuscarInputLargoMax"
                    identificador="transporte_buscar_input_largo_max"
                    :valor-min="0"
                    :valor-max="50"
                    :valor-escala="1"
                    :valor-inicial="0"
                    titulo="Metros de largo máximo"
                  />
                </div>

                <div class="col-12 col-xxl-6">
                  <label class="fs-6 form-label fw-bolder text-dark">Metros de alto Min.</label>
                  <InputMarcador
                    ref="transporteBuscarInputAltoMin"
                    identificador="transporte_buscar_input_alto_min"
                    :valor-min="0"
                    :valor-max="50"
                    :valor-escala="1"
                    :valor-inicial="0"
                    titulo="Metros de alto mínimo"
                  />
                </div>

                <div class="col-12 col-xxl-6">
                  <label class="fs-6 form-label fw-bolder text-dark">Metros de alto Max.</label>
                  <InputMarcador
                    ref="transporteBuscarInputAltoMax"
                    identificador="transporte_buscar_input_alto_max"
                    :valor-min="0"
                    :valor-max="50"
                    :valor-escala="1"
                    :valor-inicial="0"
                    titulo="Metros de alto máximo"
                  />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="col-12 col-md-8 col-lg-7 col-xl-8 mt-2">
        <mapa-buscar :transportes="transportes" />
      </div>
    </div>
  </div>
</template>
<script>
import MapaBuscar from "@/components/panel/transporte/MapaTransporteBuscar";
import InputMarcador from "@/components/util/InputMarcador";

import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import BloqueoUI from "@/core/util/BloqueoUI";

export default {
  name: 'TransporteBuscar',
  components: {
    MapaBuscar, InputMarcador
  },
  data() {
    return {
      mFormulario: {
        toneladaMin: '',
        toneladaMax: '',
        precioMin: 0,
        precioMax: 0,
        pesoMin: 0,
        pesoMax: 0,
      },
      componentes: {
        bloqueoUI: null,
      },
      transportes: [],
    }
  },

  mounted() {
    this.componentes.bloqueoUI = new BloqueoUI('#transporte_buscar_formulario', '#transporte_buscar_btn_buscar');
  },
  methods: {
    onTransporteBuscar() {
      this.transportes = [];
      this.mFormulario.largoMin = this.$refs.transporteBuscarInputLargoMin.getValor();
      this.mFormulario.largoMax = this.$refs.transporteBuscarInputLargoMax.getValor();
      this.mFormulario.altoMin = this.$refs.transporteBuscarInputAltoMin.getValor();
      this.mFormulario.altoMax = this.$refs.transporteBuscarInputAltoMax.getValor();
      this.componentes.bloqueoUI.iniciarBloqueoFormulario();

      Servicio.post(Ruta.PANEL_TRANSPORTE_BUSCAR, this.mFormulario).then( (data) => {
        this.transportes = data.data;
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
      }).catch( (error) => {
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Toast.mostrarError(error);
      });
    },
  },

}
</script>